Index: /branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.h	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.h	(revision 1442)
@@ -86,5 +86,5 @@
   UChar*        m_puhDepth;           ///< array of depths
   Int           m_unitSize;           ///< size of a "minimum partition"
-  
+
 #if SVC_EXTENSION
   UInt          m_layerId;          ///< layer id
@@ -99,9 +99,9 @@
 
   Bool*          m_skipFlag;           ///< array of skip flags
-  Char*          m_pePartSize;         ///< array of partition sizes
-  Char*          m_pePredMode;         ///< array of prediction modes
-  Char*          m_crossComponentPredictionAlpha[MAX_NUM_COMPONENT]; ///< array of cross-component prediction alpha values
+  SChar*         m_pePartSize;         ///< array of partition sizes
+  SChar*         m_pePredMode;         ///< array of prediction modes
+  SChar*         m_crossComponentPredictionAlpha[MAX_NUM_COMPONENT]; ///< array of cross-component prediction alpha values
   Bool*          m_CUTransquantBypass;   ///< array of cu_transquant_bypass flags
-  Char*          m_phQP;               ///< array of QP values
+  SChar*         m_phQP;               ///< array of QP values
   UChar*         m_ChromaQpAdj;        ///< array of chroma QP adjustments (indexed). when value = 0, cu_chroma_qp_offset_flag=0; when value>0, indicates cu_chroma_qp_offset_flag=1 and cu_chroma_qp_offset_idx=value-1
   UInt           m_codedChromaQpAdj;
@@ -143,6 +143,6 @@
   UChar*        m_puhIntraDir[MAX_NUM_CHANNEL_TYPE]; // 0-> Luma, 1-> Chroma
   UChar*        m_puhInterDir;        ///< array of inter directions
-  Char*         m_apiMVPIdx[NUM_REF_PIC_LIST_01];       ///< array of motion vector predictor candidates
-  Char*         m_apiMVPNum[NUM_REF_PIC_LIST_01];       ///< array of number of possible motion vectors predictors
+  SChar*        m_apiMVPIdx[NUM_REF_PIC_LIST_01];       ///< array of motion vector predictor candidates
+  SChar*        m_apiMVPNum[NUM_REF_PIC_LIST_01];       ///< array of number of possible motion vectors predictors
   Bool*         m_pbIPCMFlag;         ///< array of intra_pcm flags
 
@@ -156,5 +156,5 @@
   UInt          m_uiTotalBits;        ///< sum of partition bits
   UInt          m_uiTotalBins;        ///< sum of partition bins
-  Char          m_codedQP;
+  SChar         m_codedQP;
   UChar*        m_explicitRdpcmMode[MAX_NUM_COMPONENT]; ///< Stores the explicit RDPCM mode for all TUs belonging to this CU
 
@@ -223,5 +223,5 @@
   // -------------------------------------------------------------------------------------------------------------------
 
-  Char*         getPartitionSize      ()                        { return m_pePartSize;        }
+  SChar*        getPartitionSize      ()                        { return m_pePartSize;        }
   PartSize      getPartitionSize      ( UInt uiIdx )            { return static_cast<PartSize>( m_pePartSize[uiIdx] ); }
   Void          setPartitionSize      ( UInt uiIdx, PartSize uh){ m_pePartSize[uiIdx] = uh;   }
@@ -234,11 +234,11 @@
   Void          setSkipFlagSubParts   ( Bool skip, UInt absPartIdx, UInt depth );
 
-  Char*         getPredictionMode     ()                        { return m_pePredMode;        }
+  SChar*        getPredictionMode     ()                        { return m_pePredMode;        }
   PredMode      getPredictionMode     ( UInt uiIdx )            { return static_cast<PredMode>( m_pePredMode[uiIdx] ); }
   Void          setPredictionMode     ( UInt uiIdx, PredMode uh){ m_pePredMode[uiIdx] = uh;   }
   Void          setPredModeSubParts   ( PredMode eMode, UInt uiAbsPartIdx, UInt uiDepth );
 
-  Char*         getCrossComponentPredictionAlpha( ComponentID compID )             { return m_crossComponentPredictionAlpha[compID];         }
-  Char          getCrossComponentPredictionAlpha( UInt uiIdx, ComponentID compID ) { return m_crossComponentPredictionAlpha[compID][uiIdx];  }
+  SChar*        getCrossComponentPredictionAlpha( ComponentID compID )             { return m_crossComponentPredictionAlpha[compID];         }
+  SChar         getCrossComponentPredictionAlpha( UInt uiIdx, ComponentID compID ) { return m_crossComponentPredictionAlpha[compID][uiIdx];  }
 
   Bool*         getCUTransquantBypass ()                        { return m_CUTransquantBypass;        }
@@ -255,13 +255,13 @@
   Void          setSizeSubParts       ( UInt uiWidth, UInt uiHeight, UInt uiAbsPartIdx, UInt uiDepth );
 
-  Char*         getQP                 ()                        { return m_phQP;              }
-  Char          getQP                 ( UInt uiIdx ) const      { return m_phQP[uiIdx];       }
-  Void          setQP                 ( UInt uiIdx, Char value ){ m_phQP[uiIdx] =  value;     }
+  SChar*        getQP                 ()                        { return m_phQP;              }
+  SChar         getQP                 ( UInt uiIdx ) const      { return m_phQP[uiIdx];       }
+  Void          setQP                 ( UInt uiIdx, SChar value){ m_phQP[uiIdx] =  value;     }
   Void          setQPSubParts         ( Int qp,   UInt uiAbsPartIdx, UInt uiDepth );
   Int           getLastValidPartIdx   ( Int iAbsPartIdx );
-  Char          getLastCodedQP        ( UInt uiAbsPartIdx );
+  SChar         getLastCodedQP        ( UInt uiAbsPartIdx );
   Void          setQPSubCUs           ( Int qp, UInt absPartIdx, UInt depth, Bool &foundNonZeroCbf );
-  Void          setCodedQP            ( Char qp )               { m_codedQP = qp;             }
-  Char          getCodedQP            ()                        { return m_codedQP;           }
+  Void          setCodedQP            ( SChar qp )              { m_codedQP = qp;             }
+  SChar         getCodedQP            ()                        { return m_codedQP;           }
 
   UChar*        getChromaQpAdj        ()                        { return m_ChromaQpAdj;       } ///< array of chroma QP adjustments (indexed). when value = 0, cu_chroma_qp_offset_flag=0; when value>0, indicates cu_chroma_qp_offset_flag=1 and cu_chroma_qp_offset_idx=value-1
@@ -269,6 +269,6 @@
   Void          setChromaQpAdj        (Int idx, UChar val)      { m_ChromaQpAdj[idx] = val;   } ///< When val = 0,   cu_chroma_qp_offset_flag=0; when val>0,   indicates cu_chroma_qp_offset_flag=1 and cu_chroma_qp_offset_idx=val-1
   Void          setChromaQpAdjSubParts( UChar val, Int absPartIdx, Int depth );
-  Void          setCodedChromaQpAdj   ( Char qp )               { m_codedChromaQpAdj = qp;    }
-  Char          getCodedChromaQpAdj   ()                        { return m_codedChromaQpAdj;  }
+  Void          setCodedChromaQpAdj   ( SChar qp )              { m_codedChromaQpAdj = qp;    }
+  SChar         getCodedChromaQpAdj   ()                        { return m_codedChromaQpAdj;  }
 
   Bool          isLosslessCoded       ( UInt absPartIdx );
@@ -289,5 +289,5 @@
   Bool          isRDPCMEnabled         ( UInt uiAbsPartIdx )  { return getSlice()->getSPS()->getSpsRangeExtension().getRdpcmEnabledFlag(isIntra(uiAbsPartIdx) ? RDPCM_SIGNAL_IMPLICIT : RDPCM_SIGNAL_EXPLICIT); }
 
-  Void          setCrossComponentPredictionAlphaPartRange    ( Char alphaValue, ComponentID compID, UInt uiAbsPartIdx, UInt uiCoveredPartIdxes );
+  Void          setCrossComponentPredictionAlphaPartRange    ( SChar alphaValue, ComponentID compID, UInt uiAbsPartIdx, UInt uiCoveredPartIdxes );
   Void          setTransformSkipPartRange                    ( UInt useTransformSkip, ComponentID compID, UInt uiAbsPartIdx, UInt uiCoveredPartIdxes );
 
@@ -375,9 +375,9 @@
   Void          setMVPIdx             ( RefPicList eRefPicList, UInt uiIdx, Int iMVPIdx)  { m_apiMVPIdx[eRefPicList][uiIdx] = iMVPIdx;  }
   Int           getMVPIdx             ( RefPicList eRefPicList, UInt uiIdx)               { return m_apiMVPIdx[eRefPicList][uiIdx];     }
-  Char*         getMVPIdx             ( RefPicList eRefPicList )                          { return m_apiMVPIdx[eRefPicList];            }
+  SChar*        getMVPIdx             ( RefPicList eRefPicList )                          { return m_apiMVPIdx[eRefPicList];            }
 
   Void          setMVPNum             ( RefPicList eRefPicList, UInt uiIdx, Int iMVPNum ) { m_apiMVPNum[eRefPicList][uiIdx] = iMVPNum;  }
   Int           getMVPNum             ( RefPicList eRefPicList, UInt uiIdx )              { return m_apiMVPNum[eRefPicList][uiIdx];     }
-  Char*         getMVPNum             ( RefPicList eRefPicList )                          { return m_apiMVPNum[eRefPicList];            }
+  SChar*        getMVPNum             ( RefPicList eRefPicList )                          { return m_apiMVPNum[eRefPicList];            }
 
   Void          setMVPIdxSubParts     ( Int iMVPIdx, RefPicList eRefPicList, UInt uiAbsPartIdx, UInt uiPartIdx, UInt uiDepth );
@@ -420,5 +420,5 @@
   TComDataCU*   getQpMinCuLeft              ( UInt&  uiLPartUnitIdx , UInt uiCurrAbsIdxInCtu );
   TComDataCU*   getQpMinCuAbove             ( UInt&  uiAPartUnitIdx , UInt uiCurrAbsIdxInCtu );
-  Char          getRefQP                    ( UInt   uiCurrAbsIdxInCtu                       );
+  SChar         getRefQP                    ( UInt   uiCurrAbsIdxInCtu                       );
 
   /// returns CU and part index of the PU above the top row of the current uiCurrPartUnitIdx of the CU, at a horizontal offset (to the right) of uiPartUnitOffset (in parts)
@@ -475,5 +475,5 @@
 
   UInt          getCoefScanIdx(const UInt uiAbsPartIdx, const UInt uiWidth, const UInt uiHeight, const ComponentID compID) const ;
- 
+
 #if SVC_EXTENSION
   Void          setLayerId (UInt layerId)       { m_layerId = layerId; }
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComMotionInfo.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComMotionInfo.cpp	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComMotionInfo.cpp	(revision 1442)
@@ -60,5 +60,5 @@
   m_pcMv     = new TComMv[ uiNumPartition ];
   m_pcMvd    = new TComMv[ uiNumPartition ];
-  m_piRefIdx = new Char  [ uiNumPartition ];
+  m_piRefIdx = new SChar [ uiNumPartition ];
 
   m_uiNumPartition = uiNumPartition;
@@ -315,5 +315,5 @@
 Void TComCUMvField::setAllRefIdx ( Int iRefIdx, PartSize eCUMode, Int iPartAddr, UInt uiDepth, Int iPartIdx )
 {
-  setAll(m_piRefIdx, static_cast<Char>(iRefIdx), eCUMode, iPartAddr, uiDepth, iPartIdx);
+  setAll(m_piRefIdx, static_cast<SChar>(iRefIdx), eCUMode, iPartAddr, uiDepth, iPartIdx);
 }
 
@@ -328,5 +328,5 @@
  * \param scale      Factor by which to subsample motion information
  */
-Void TComCUMvField::compress(Char* pePredMode, Int scale)
+Void TComCUMvField::compress(SChar* pePredMode, Int scale)
 {
   Int N = scale * scale;
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComMotionInfo.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComMotionInfo.h	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComMotionInfo.h	(revision 1442)
@@ -94,5 +94,5 @@
   TComMv*   m_pcMv;
   TComMv*   m_pcMvd;
-  Char*     m_piRefIdx;
+  SChar*    m_piRefIdx;
   UInt      m_uiNumPartition;
   AMVPInfo  m_cAMVPInfo;
@@ -153,5 +153,5 @@
   }
 
-  Void compress(Char* pePredMode, Int scale);
+  Void compress(SChar* pePredMode, Int scale);
 
 #if SVC_EXTENSION
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComPic.cpp	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComPic.cpp	(revision 1442)
@@ -363,5 +363,5 @@
       }
     }
-    memset( pcCUDes->getPartitionSize(), SIZE_2Nx2N, sizeof(Char)*numPartitions );
+    memset( pcCUDes->getPartitionSize(), SIZE_2Nx2N, sizeof(SChar)*numPartitions );
   }
 }
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1442)
@@ -296,16 +296,7 @@
 
 // NOTE: This function is never called, but may be useful for developers.
-Void TComPicYuv::dump (const Char* pFileName, const BitDepths &bitDepths, Bool bAdd) const
-{
-  FILE* pFile;
-  if (!bAdd)
-  {
-    pFile = fopen (pFileName, "wb");
-  }
-  else
-  {
-    pFile = fopen (pFileName, "ab");
-  }
-
+Void TComPicYuv::dump (const std::string &fileName, const BitDepths &bitDepths, Bool bAdd) const
+{
+  FILE* pFile = fopen (fileName.c_str(), bAdd?"ab":"wb");
 
   for(Int comp = 0; comp < getNumberValidComponents(); comp++)
@@ -333,19 +324,11 @@
 }
 
-Void TComPicYuv::dump( Char* pFileName, Bool bAdd, Int bitDepth )
-{
-  FILE* pFile;
-  if (!bAdd)
-  {
-    pFile = fopen (pFileName, "wb");
-  }
-  else
-  {
-    pFile = fopen (pFileName, "ab");
-  }
+Void TComPicYuv::dump( const std::string &fileName, const Bool bAdd, const Int bitDepth )
+{
+  FILE* pFile = fopen (fileName.c_str(), bAdd?"ab":"wb");
 
   if( bitDepth == 8 )
   {
-    dump( pFileName, bitDepth, bAdd );
+    dump( fileName, bitDepth, bAdd );
     return;
   }
@@ -378,5 +361,5 @@
 
 #if AUXILIARY_PICTURES
-Void TComPicYuv::convertToMonochrome(Int bitDepthChroma)
+Void TComPicYuv::convertToMonochrome(const Int bitDepthChroma)
 {
   Pel grayVal = (1 << (bitDepthChroma - 1));
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.h	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuv.h	(revision 1442)
@@ -180,5 +180,5 @@
 
   //  Dump picture
-  Void          dump              (const Char* pFileName, const BitDepths &bitDepths, Bool bAdd = false) const ;
+  Void          dump              (const std::string &fileName, const BitDepths &bitDepths, Bool bAdd = false) const ;
 
   // Set border extension flag
@@ -192,9 +192,9 @@
   Bool          isReconstructed()                                { return m_isReconstructed;                }
 #if AUXILIARY_PICTURES  
-  Void          convertToMonochrome(Int bitDepthChroma);
-#endif
-#endif
-
-  Void          dump( Char* pFileName, Bool bAdd, Int bitDepth );
+  Void          convertToMonochrome(const Int bitDepthChroma);
+#endif
+#endif
+
+  Void          dump( const std::string &fileName, const Bool bAdd, const Int bitDepth );
 
 };// END CLASS DEFINITION TComPicYuv
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuvMD5.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1442)
@@ -209,5 +209,5 @@
 std::string hashToString(const TComPictureHash &digest, Int numChar)
 {
-  static const Char* hex = "0123456789abcdef";
+  static const TChar* hex = "0123456789abcdef";
   std::string result;
 
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComRom.cpp	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComRom.cpp	(revision 1442)
@@ -51,5 +51,5 @@
 //! \{
 
-const Char* nalUnitTypeToString(NalUnitType type)
+const TChar* nalUnitTypeToString(NalUnitType type)
 {
 #if SVC_EXTENSION
@@ -602,5 +602,5 @@
 // ====================================================================================================================
 
-Char  g_aucConvertToBit  [ MAX_CU_SIZE+1 ];
+SChar  g_aucConvertToBit  [ MAX_CU_SIZE+1 ];
 
 #if ENC_DEC_TRACE
@@ -630,5 +630,5 @@
 const UInt g_uiGroupIdx[ MAX_TU_SIZE ]   = {0,1,2,3,4,4,5,5,6,6,6,6,7,7,7,7,8,8,8,8,8,8,8,8,9,9,9,9,9,9,9,9};
 
-const Char *MatrixType[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM] =
+const TChar *MatrixType[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM] =
 {
   {
@@ -666,5 +666,5 @@
 };
 
-const Char *MatrixType_DC[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM] =
+const TChar *MatrixType_DC[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM] =
 {
   {
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComRom.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComRom.h	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComRom.h	(revision 1442)
@@ -125,5 +125,5 @@
 // ====================================================================================================================
 
-extern       Char   g_aucConvertToBit  [ MAX_CU_SIZE+1 ];   // from width to log2(width)-2
+extern       SChar   g_aucConvertToBit  [ MAX_CU_SIZE+1 ];   // from width to log2(width)-2
 
 
@@ -159,8 +159,8 @@
 #endif
 
-const Char* nalUnitTypeToString(NalUnitType type);
+const TChar* nalUnitTypeToString(NalUnitType type);
 
-extern const Char *MatrixType[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM];
-extern const Char *MatrixType_DC[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM];
+extern const TChar *MatrixType[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM];
+extern const TChar *MatrixType_DC[SCALING_LIST_SIZE_NUM][SCALING_LIST_NUM];
 
 extern const Int g_quantTSDefault4x4[4*4];
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 1442)
@@ -324,5 +324,5 @@
       m_signLineBuf1 = NULL;
     }
-    m_signLineBuf1 = new Char[m_lineBufWidth+1];
+    m_signLineBuf1 = new SChar[m_lineBufWidth+1];
 
     if (m_signLineBuf2)
@@ -331,5 +331,5 @@
       m_signLineBuf2 = NULL;
     }
-    m_signLineBuf2 = new Char[m_lineBufWidth+1];
+    m_signLineBuf2 = new SChar[m_lineBufWidth+1];
   }
 
@@ -338,5 +338,5 @@
   Int x,y, startX, startY, endX, endY, edgeType;
   Int firstLineStartX, firstLineEndX, lastLineStartX, lastLineEndX;
-  Char signLeft, signRight, signDown;
+  SChar signLeft, signRight, signDown;
 
   Pel* srcLine = srcBlk;
@@ -352,8 +352,8 @@
       for (y=0; y< height; y++)
       {
-        signLeft = (Char)sgn(srcLine[startX] - srcLine[startX-1]);
+        signLeft = (SChar)sgn(srcLine[startX] - srcLine[startX-1]);
         for (x=startX; x< endX; x++)
         {
-          signRight = (Char)sgn(srcLine[x] - srcLine[x+1]); 
+          signRight = (SChar)sgn(srcLine[x] - srcLine[x+1]);
           edgeType =  signRight + signLeft;
           signLeft  = -signRight;
@@ -370,5 +370,5 @@
     {
       offset += 2;
-      Char *signUpLine = m_signLineBuf1;
+      SChar *signUpLine = m_signLineBuf1;
 
       startY = isAboveAvail ? 0 : 1;
@@ -383,5 +383,5 @@
       for (x=0; x< width; x++)
       {
-        signUpLine[x] = (Char)sgn(srcLine[x] - srcLineAbove[x]);
+        signUpLine[x] = (SChar)sgn(srcLine[x] - srcLineAbove[x]);
       }
 
@@ -393,5 +393,5 @@
         for (x=0; x< width; x++)
         {
-          signDown  = (Char)sgn(srcLine[x] - srcLineBelow[x]);
+          signDown  = (SChar)sgn(srcLine[x] - srcLineBelow[x]);
           edgeType = signDown + signUpLine[x];
           signUpLine[x]= -signDown;
@@ -408,5 +408,5 @@
     {
       offset += 2;
-      Char *signUpLine, *signDownLine, *signTmpLine;
+      SChar *signUpLine, *signDownLine, *signTmpLine;
 
       signUpLine  = m_signLineBuf1;
@@ -420,5 +420,5 @@
       for (x=startX; x< endX+1; x++)
       {
-        signUpLine[x] = (Char)sgn(srcLineBelow[x] - srcLine[x- 1]);
+        signUpLine[x] = (SChar)sgn(srcLineBelow[x] - srcLine[x- 1]);
       }
 
@@ -444,5 +444,5 @@
         for (x=startX; x<endX; x++)
         {
-          signDown =  (Char)sgn(srcLine[x] - srcLineBelow[x+ 1]);
+          signDown =  (SChar)sgn(srcLine[x] - srcLineBelow[x+ 1]);
           edgeType =  signDown + signUpLine[x];
           resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
@@ -450,5 +450,5 @@
           signDownLine[x+1] = -signDown;
         }
-        signDownLine[startX] = (Char)sgn(srcLineBelow[startX] - srcLine[startX-1]);
+        signDownLine[startX] = (SChar)sgn(srcLineBelow[startX] - srcLine[startX-1]);
 
         signTmpLine  = signUpLine;
@@ -475,5 +475,5 @@
     {
       offset += 2;
-      Char *signUpLine = m_signLineBuf1+1;
+      SChar *signUpLine = m_signLineBuf1+1;
 
       startX = isLeftAvail ? 0 : 1;
@@ -484,5 +484,5 @@
       for (x=startX-1; x< endX; x++)
       {
-        signUpLine[x] = (Char)sgn(srcLineBelow[x] - srcLine[x+1]);
+        signUpLine[x] = (SChar)sgn(srcLineBelow[x] - srcLine[x+1]);
       }
 
@@ -507,10 +507,10 @@
         for(x= startX; x< endX; x++)
         {
-          signDown =  (Char)sgn(srcLine[x] - srcLineBelow[x-1]);
+          signDown =  (SChar)sgn(srcLine[x] - srcLineBelow[x-1]);
           edgeType =  signDown + signUpLine[x];
           resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
           signUpLine[x-1] = -signDown;
         }
-        signUpLine[endX-1] = (Char)sgn(srcLineBelow[endX-1] - srcLine[endX]);
+        signUpLine[endX-1] = (SChar)sgn(srcLineBelow[endX-1] - srcLine[endX]);
         srcLine  += srcStride;
         resLine += resStride;
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h	(revision 1442)
@@ -96,6 +96,6 @@
 
   Int m_lineBufWidth;
-  Char* m_signLineBuf1;
-  Char* m_signLineBuf2;
+  SChar* m_signLineBuf1;
+  SChar* m_signLineBuf2;
   ChromaFormat m_chromaFormatIDC;
 private:
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.cpp	(revision 1442)
@@ -2444,11 +2444,11 @@
 }
 
-Bool TComScalingList::xParseScalingList(Char* pchFile)
+Bool TComScalingList::xParseScalingList(const std::string &fileName)
 {
   static const Int LINE_SIZE=1024;
   FILE *fp = NULL;
-  Char line[LINE_SIZE];
-
-  if (pchFile == NULL)
+  TChar line[LINE_SIZE];
+
+  if (fileName.empty())
   {
     fprintf(stderr, "Error: no scaling list file specified. Help on scaling lists being output\n");
@@ -2459,7 +2459,7 @@
     return true;
   }
-  else if ((fp = fopen(pchFile,"r")) == (FILE*)NULL)
-  {
-    fprintf(stderr, "Error: cannot open scaling list file %s for reading\n",pchFile);
+  else if ((fp = fopen(fileName.c_str(),"r")) == (FILE*)NULL)
+  {
+    fprintf(stderr, "Error: cannot open scaling list file %s for reading\n", fileName.c_str());
     return true;
   }
@@ -2489,6 +2489,6 @@
           while ((!feof(fp)) && (!bFound))
           {
-            Char *ret = fgets(line, LINE_SIZE, fp);
-            Char *findNamePosition= ret==NULL ? NULL : strstr(line, MatrixType[sizeIdc][listIdc]);
+            TChar *ret = fgets(line, LINE_SIZE, fp);
+            TChar *findNamePosition= ret==NULL ? NULL : strstr(line, MatrixType[sizeIdc][listIdc]);
             // This could be a match against the DC string as well, so verify it isn't
             if (findNamePosition!= NULL && (MatrixType_DC[sizeIdc][listIdc]==NULL || strstr(line, MatrixType_DC[sizeIdc][listIdc])==NULL))
@@ -2499,5 +2499,5 @@
           if (!bFound)
           {
-            fprintf(stderr, "Error: cannot find Matrix %s from scaling list file %s\n", MatrixType[sizeIdc][listIdc], pchFile);
+            fprintf(stderr, "Error: cannot find Matrix %s from scaling list file %s\n", MatrixType[sizeIdc][listIdc], fileName.c_str());
             return true;
           }
@@ -2508,10 +2508,10 @@
           if (fscanf(fp, "%d,", &data)!=1)
           {
-            fprintf(stderr, "Error: cannot read value #%d for Matrix %s from scaling list file %s at file position %ld\n", i, MatrixType[sizeIdc][listIdc], pchFile, ftell(fp));
+            fprintf(stderr, "Error: cannot read value #%d for Matrix %s from scaling list file %s at file position %ld\n", i, MatrixType[sizeIdc][listIdc], fileName.c_str(), ftell(fp));
             return true;
           }
           if (data<0 || data>255)
           {
-            fprintf(stderr, "Error: QMatrix entry #%d of value %d for Matrix %s from scaling list file %s at file position %ld is out of range (0 to 255)\n", i, data, MatrixType[sizeIdc][listIdc], pchFile, ftell(fp));
+            fprintf(stderr, "Error: QMatrix entry #%d of value %d for Matrix %s from scaling list file %s at file position %ld is out of range (0 to 255)\n", i, data, MatrixType[sizeIdc][listIdc], fileName.c_str(), ftell(fp));
             return true;
           }
@@ -2529,6 +2529,6 @@
             while ((!feof(fp)) && (!bFound))
             {
-              Char *ret = fgets(line, LINE_SIZE, fp);
-              Char *findNamePosition= ret==NULL ? NULL : strstr(line, MatrixType_DC[sizeIdc][listIdc]);
+              TChar *ret = fgets(line, LINE_SIZE, fp);
+              TChar *findNamePosition= ret==NULL ? NULL : strstr(line, MatrixType_DC[sizeIdc][listIdc]);
               if (findNamePosition!= NULL)
               {
@@ -2539,5 +2539,5 @@
             if (!bFound)
             {
-              fprintf(stderr, "Error: cannot find DC Matrix %s from scaling list file %s\n", MatrixType_DC[sizeIdc][listIdc], pchFile);
+              fprintf(stderr, "Error: cannot find DC Matrix %s from scaling list file %s\n", MatrixType_DC[sizeIdc][listIdc], fileName.c_str());
               return true;
             }
@@ -2546,10 +2546,10 @@
           if (fscanf(fp, "%d,", &data)!=1)
           {
-            fprintf(stderr, "Error: cannot read DC %s from scaling list file %s at file position %ld\n", MatrixType_DC[sizeIdc][listIdc], pchFile, ftell(fp));
+            fprintf(stderr, "Error: cannot read DC %s from scaling list file %s at file position %ld\n", MatrixType_DC[sizeIdc][listIdc], fileName.c_str(), ftell(fp));
             return true;
           }
           if (data<0 || data>255)
           {
-            fprintf(stderr, "Error: DC value %d for Matrix %s from scaling list file %s at file position %ld is out of range (0 to 255)\n", data, MatrixType[sizeIdc][listIdc], pchFile, ftell(fp));
+            fprintf(stderr, "Error: DC value %d for Matrix %s from scaling list file %s at file position %ld is out of range (0 to 255)\n", data, MatrixType[sizeIdc][listIdc], fileName.c_str(), ftell(fp));
             return true;
           }
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.h	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComSlice.h	(revision 1442)
@@ -176,5 +176,5 @@
   Void       checkDcOfMatrix();
   Void       processRefMatrix(UInt sizeId, UInt listId , UInt refListId );
-  Bool       xParseScalingList(Char* pchFile);
+  Bool       xParseScalingList(const std::string &fileName);
   Void       setDefaultScalingList();
   Bool       checkDefaultScalingList();
@@ -789,5 +789,5 @@
   UInt              getNumHrdParameters() const                          { return m_numHrdParameters;                                       }
   Void              setNumHrdParameters(UInt v)                          { m_numHrdParameters = v;                                          }
-  
+
 #if !SVC_EXTENSION
   UInt              getMaxNuhReservedZeroLayerId() const                 { return m_maxNuhReservedZeroLayerId;                              }
@@ -1140,4 +1140,5 @@
 #endif //SVC_EXTENSION
 };
+
 
 class TComVUI
Index: /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TypeDef.h	(revision 1442)
@@ -259,10 +259,7 @@
 typedef       bool                Bool;
 
-#ifdef __arm__
-typedef       signed char         Char;
-#else
-typedef       char                Char;
-#endif
-typedef       unsigned char       UChar;
+typedef       char                TChar; // Used for text/characters
+typedef       signed char         SChar; // Signed 8-bit values
+typedef       unsigned char       UChar; // Unsigned 8-bit values
 typedef       short               Short;
 typedef       unsigned short      UShort;
Index: /branches/SHM-dev/source/Lib/TLibDecoder/SEIread.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/SEIread.cpp	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/SEIread.cpp	(revision 1442)
@@ -63,5 +63,5 @@
 #endif
 
-Void SEIReader::sei_read_code(std::ostream *pOS, UInt uiLength, UInt& ruiCode, const Char *pSymbolName)
+Void SEIReader::sei_read_code(std::ostream *pOS, UInt uiLength, UInt& ruiCode, const TChar *pSymbolName)
 {
   READ_CODE(uiLength, ruiCode, pSymbolName);
@@ -72,5 +72,5 @@
 }
 
-Void SEIReader::sei_read_uvlc(std::ostream *pOS, UInt& ruiCode, const Char *pSymbolName)
+Void SEIReader::sei_read_uvlc(std::ostream *pOS, UInt& ruiCode, const TChar *pSymbolName)
 {
   READ_UVLC(ruiCode, pSymbolName);
@@ -81,5 +81,5 @@
 }
 
-Void SEIReader::sei_read_svlc(std::ostream *pOS, Int& ruiCode, const Char *pSymbolName)
+Void SEIReader::sei_read_svlc(std::ostream *pOS, Int& ruiCode, const TChar *pSymbolName)
 {
   READ_SVLC(ruiCode, pSymbolName);
@@ -90,5 +90,5 @@
 }
 
-Void SEIReader::sei_read_flag(std::ostream *pOS, UInt& ruiCode, const Char *pSymbolName)
+Void SEIReader::sei_read_flag(std::ostream *pOS, UInt& ruiCode, const TChar *pSymbolName)
 {
   READ_FLAG(ruiCode, pSymbolName);
@@ -522,5 +522,5 @@
   sei.method = static_cast<SEIDecodedPictureHash::Method>(val); bytesRead++;
 
-  const Char *traceString="\0";
+  const TChar *traceString="\0";
   switch (sei.method)
   {
Index: /branches/SHM-dev/source/Lib/TLibDecoder/SEIread.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibDecoder/SEIread.h	(revision 1441)
+++ /branches/SHM-dev/source/Lib/TLibDecoder/SEIread.h	(revision 1442)
@@ -109,8 +109,8 @@
   Void xParseSEIMasteringDisplayColourVolume  (SEIMasteringDisplayColourVolume& sei,  UInt payloadSize,                     std::ostream *pDecodedMessageOutputStream);
 
-  Void sei_read_code(std::ostream *pOS, UInt uiLength, UInt& ruiCode, const Char *pSymbolName);
-  Void sei_read_uvlc(std::ostream *pOS,                UInt& ruiCode, const Char *pSymbolName);
-  Void sei_read_svlc(std::ostream *pOS,                Int&  ruiCode, const Char *pSymbolName);
-  Void sei_read_flag(std::ostream *pOS,                UInt& ruiCode, const Char *pSymbolName);
+  Void sei_read_code(std::ostream *pOS, UInt uiLength, UInt& ruiCode, const TChar *pSymbolName);
+  Void sei_read_uvlc(std::ostream *pOS,                UInt& ruiCode, const TChar *pSymbolName);
+  Void sei_read_svlc(std::ostream *pOS,                Int&  ruiCode, const TChar *pSymbolName);
+  Void sei_read_flag(std::ostream *pOS,                UInt& ruiCode, const TChar *pSymbolName);
 
 #if Q0074_COLOUR_REMAPPING_SEI
